package com.zcloud.personnel.positioning.web;

import com.zcloud.personnel.positioning.api.AlarmDisposeRecordServiceI;
import com.zcloud.personnel.positioning.dto.AlarmDisposeRecordAddCmd;
import com.zcloud.personnel.positioning.dto.AlarmDisposeRecordPageQry;
import com.zcloud.personnel.positioning.dto.AlarmDisposeRecordUpdateCmd;
import com.zcloud.personnel.positioning.dto.clientobject.AlarmDisposeRecordCO;
import com.alibaba.cola.dto.MultiResponse;
import com.alibaba.cola.dto.PageResponse;
import com.alibaba.cola.dto.Response;
import com.alibaba.cola.dto.SingleResponse;
import com.jjb.saas.framework.auth.model.SSOUser;
import com.jjb.saas.framework.auth.utils.AuthContext;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import lombok.AllArgsConstructor;
import org.springframework.validation.annotation.Validated;
import org.springframework.web.bind.annotation.DeleteMapping;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.PutMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.RestController;

/**
 * web-adapter
 *
 * @Author fangjiakai
 * @Date 2026-07-07
 */
@Api(tags = "告警处置记录")
@RequestMapping("/${application.gateway}/alarmDisposeRecord")
@RestController
@AllArgsConstructor
public class AlarmDisposeRecordController {
    private final AlarmDisposeRecordServiceI alarmDisposeRecordService;

    @ApiOperation("新增")
    @PostMapping("/save")
    public SingleResponse<AlarmDisposeRecordCO> add(@Validated @RequestBody AlarmDisposeRecordAddCmd cmd) {
        fillCorpinfo(cmd);
        return alarmDisposeRecordService.add(cmd);
    }

    @ApiOperation("分页")
    @PostMapping("/list")
    public PageResponse<AlarmDisposeRecordCO> page(@RequestBody AlarmDisposeRecordPageQry qry) {
        return alarmDisposeRecordService.listPage(qry);
    }

    @ApiOperation("所有数据")
    @GetMapping("/listAll")
    public MultiResponse<AlarmDisposeRecordCO> listAll() {
        return MultiResponse.of(alarmDisposeRecordService.listAll());
    }

    @ApiOperation("详情")
    @GetMapping("/{id}")
    public SingleResponse<AlarmDisposeRecordCO> getInfoById(@PathVariable("id") Long id) {
        return SingleResponse.of(alarmDisposeRecordService.queryById(id));
    }

    @ApiOperation("删除")
    @DeleteMapping("/{id}")
    public Response remove(@PathVariable("id") Long id) {
        alarmDisposeRecordService.remove(id);
        return SingleResponse.buildSuccess();
    }

    @ApiOperation("删除多个")
    @DeleteMapping("/ids")
    public Response removeBatch(@RequestParam Long[] ids) {
        alarmDisposeRecordService.removeBatch(ids);
        return SingleResponse.buildSuccess();
    }

    @ApiOperation("修改")
    @PutMapping("/edit")
    public SingleResponse edit(@Validated @RequestBody AlarmDisposeRecordUpdateCmd cmd) {
        fillCorpinfo(cmd);
        alarmDisposeRecordService.edit(cmd);
        return SingleResponse.buildSuccess();
    }

    private void fillCorpinfo(AlarmDisposeRecordAddCmd cmd) {
        SSOUser ssoUser = AuthContext.getCurrentUser();
        if (ssoUser != null && ssoUser.getCompanyId() != null) {
            cmd.setCorpinfoId(String.valueOf(ssoUser.getCompanyId()));
        }
    }

    private void fillCorpinfo(AlarmDisposeRecordUpdateCmd cmd) {
        SSOUser ssoUser = AuthContext.getCurrentUser();
        if (ssoUser != null && ssoUser.getCompanyId() != null) {
            cmd.setCorpinfoId(String.valueOf(ssoUser.getCompanyId()));
        }
    }
}
